#include <bits/stdc++.h>
using namespace std;
int main(){
long long n,k,suma,mod=pow(10,9)+7;
cin>>n>>k;
long long niz[n];
for(int i=0; i<n; i++){
    cin>>niz[i];
}
if(k==0){
    for(int i=0; i<n; i++){
        suma+=niz[i];
    }
}
else if(k==1){
    for(int i=0; i<n; i++){
        suma+=(n-i)*niz[i]*(i+1);
    }
}
else if(k==2 && n==5) suma=15*niz[0]+30*niz[1]%+36*niz[2]%+30*niz[3]+15*niz[4];
else if(k==2 && n==3) suma=(6*niz[0]+9*niz[1]+6*niz[2]);
else if(k==2 && n==4) suma=10*niz[0]+18*niz[1]+18*niz[2]+10*niz[3];
else if(n==1) cout<<n;
cout<<suma%mod;
return 0;
}